<?php

namespace App\Controller;

use App\Http\HttpRequest;
use App\Http\HttpResponse;
use App\Http\JsonHttpResponse;
use App\HttpCodes;

class Control {

    public static function runChecked(array $schema, callable $run): HttpResponse {
        $request_body = file_get_contents('php://input');
        $payload = get_object_vars(json_decode($request_body));

        return self::runCheckedFrom($payload, $schema, $run);
    }

    public static function runCheckedFrom(array $data, array $schema, callable $run): HttpResponse {
        $fails = [];
        $request = HttpRequest::from($data, $fails, $schema);

        if (!empty($fails)) {
            return new JsonHttpResponse($fails, HttpCodes::BAD_REQUEST);
        }

        return call_user_func_array($run, [$request]);
    }


}